/*****************************************************
* Zeus CMD - OpenGL ES Tutorial 10 : Transformations *
* By Grant James (ZEUS)                              *
* http://www.zeuscmd.com                             *
*****************************************************/
#pragma comment(lib, "libGLES_CM.lib")

#define GLUTES_STATIC

#include <GLES/glutes.h>

float xrot = 0.0f;
float yrot = 0.0f;

GLfloat triangle[] = {
	-0.25f, -0.25f, 0.0f,
	0.25f, -0.25f, 0.0f,
	-0.25f, 0.25f, 0.0f
};

GLfloat square[] = {
	-0.25f, -0.25f,
	0.25f, -0.25f,
	-0.25f, 0.25f,
	0.25f, 0.25f
};

GLfloat colors[] = {
	1.0f, 0.0f, 0.0f, 1.0f,
	0.0f, 1.0f, 0.0f, 1.0f,
	0.0f, 0.0f, 1.0f, 1.0f
};

void init()
{
	glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
}

void display()
{
	glClear (GL_COLOR_BUFFER_BIT);

	// Triangle
	glShadeModel(GL_SMOOTH);

	glVertexPointer(3, GL_FLOAT, 0, triangle);
	glColorPointer(4, GL_FLOAT, 0, colors);

	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);

	glPushMatrix();
		glTranslatef(0.25f, 0.5f, 0.0f);
		glScalef(0.5f, 0.5f, 0.5f);
		glRotatef(xrot, 1.0f, 0.0f, 0.0f);
		glDrawArrays(GL_TRIANGLES, 0, 3);
	glPopMatrix();

	glDisableClientState(GL_COLOR_ARRAY);

	// Square
	glShadeModel(GL_FLAT);

	glVertexPointer(2, GL_FLOAT, 0, square);
	
	glColor4f(0.25f, 0.25f, 0.75f, 1.0f);

	glPushMatrix();
		glTranslatef(0.75f, 0.5f ,0.0f);
		glScalef(0.5f, 0.5f, 0.5f);
		glRotatef(yrot, 0.0f, 1.0f, 0.0f);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	glPopMatrix();

	glFlush ();
	glutSwapBuffers();
}

void idle()
{
	xrot += 2.0f;
	yrot += 3.0f;

	glutPostRedisplay();
}

void reshape(int width, int height)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, width, height);
	glOrthof(0.0f, 1.0f, 0.0f, 1.0f, -1.0f, 1.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void keyboard2(int key, int x, int y)
{
	switch(key)
	{
	case GLUT_KEY_UP : exit(0); break;
	}
}

void menu(int entry)
{
	switch(entry)
	{
	case 1 : exit(0); break;
	}
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);

	glutCreateWindow("10 - Transformations");

	init();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutSpecialFunc(keyboard2);

	glutIdleFunc(idle);

	glutCreateMenu(menu);
	glutAddMenuEntry("Quit", 1);

	glutAttachMenu(GLUT_LEFT_BUTTON);

	glutMainLoop();

	return 0;
}
